## freerdp 1.1.0~git20140921.1.440916e+dfsg1

=== channels/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

include(CMakeParseArguments)
include(CMakeDependentOption)

macro(define_channel_options)
	set(PREFIX "CHANNEL")

	cmake_parse_arguments(${PREFIX}
		""
		"NAME;TYPE;DESCRIPTION;SPECIFICATIONS;DEFAULT"
		""
		${ARGN})

	string(TOUPPER "CHANNEL_${CHANNEL_NAME}" CHANNEL_OPTION)
	string(TOUPPER "CHANNEL_${CHANNEL_NAME}_CLIENT" CHANNEL_CLIENT_OPTION)
	string(TOUPPER "CHANNEL_${CHANNEL_NAME}_SERVER" CHANNEL_SERVER_OPTION)
	
	if(${${CHANNEL_CLIENT_OPTION}})
		set(OPTION_CLIENT_DEFAULT ${${CHANNEL_CLIENT_OPTION}})
	endif()
	
	if(${${CHANNEL_SERVER_OPTION}})
		set(OPTION_SERVER_DEFAULT ${${CHANNEL_SERVER_OPTION}})
	endif()
	
	if(${${CHANNEL_OPTION}})
		set(OPTION_DEFAULT ${${CHANNEL_OPTION}})
	endif()
	
	if(${OPTION_CLIENT_DEFAULT} OR ${OPTION_SERVER_DEFAULT})
		set(OPTION_DEFAULT "ON")
	endif()
	
	set(CHANNEL_DEFAULT ${OPTION_DEFAULT})
		
	set(CHANNEL_OPTION_DOC "Build ${CHANNEL_NAME} ${CHANNEL_TYPE} channel")
	option(${CHANNEL_OPTION} "${CHANNEL_OPTION_DOC}" ${CHANNEL_DEFAULT})

endmacro(define_channel_options)

macro(define_channel_client_options _channel_client_default)
	string(TOUPPER "CHANNEL_${CHANNEL_NAME}_CLIENT" CHANNEL_CLIENT_OPTION)
	set(CHANNEL_CLIENT_OPTION_DOC "Build ${CHANNEL_NAME} ${CHANNEL_TYPE} channel client")
	option(${CHANNEL_CLIENT_OPTION} "${CHANNEL_CLIENT_OPTION_DOC}" ${_channel_client_default})
	cmake_dependent_option(${CHANNEL_CLIENT_OPTION} "${CHANNEL_CLIENT_OPTION_DOC}"
		${_channel_client_default} "${CHANNEL_OPTION}" OFF)
endmacro(define_channel_client_options)

macro(define_channel_server_options _channel_server_default)
	string(TOUPPER "CHANNEL_${CHANNEL_NAME}_SERVER" CHANNEL_SERVER_OPTION)
	set(CHANNEL_SERVER_OPTION_DOC "Build ${CHANNEL_NAME} ${CHANNEL_TYPE} channel server")
	option(${CHANNEL_SERVER_OPTION} "${CHANNEL_SERVER_OPTION_DOC}" ${_channel_server_default})
	cmake_dependent_option(${CHANNEL_SERVER_OPTION} "${CHANNEL_SERVER_OPTION_DOC}"
		${_channel_server_default} "${CHANNEL_OPTION}" OFF)
endmacro(define_channel_server_options)

macro(define_channel _channel_name)
	set(CHANNEL_NAME ${_channel_name})
	set(MODULE_NAME ${CHANNEL_NAME})
	string(TOUPPER "CHANNEL_${CHANNEL_NAME}" MODULE_PREFIX)
endmacro(define_channel)

macro(define_channel_client _channel_name)
	set(CHANNEL_NAME ${_channel_name})
	set(MODULE_NAME "${CHANNEL_NAME}-client")
	string(TOUPPER "CHANNEL_${CHANNEL_NAME}_CLIENT" MODULE_PREFIX)
endmacro(define_channel_client)

macro(define_channel_server _channel_name)
	set(CHANNEL_NAME ${_channel_name})
	set(MODULE_NAME "${CHANNEL_NAME}-server")
	string(TOUPPER "CHANNEL_${CHANNEL_NAME}_SERVER" MODULE_PREFIX)
endmacro(define_channel_server)

macro(define_channel_client_subsystem _channel_name _subsystem _type)
	set(CHANNEL_NAME ${_channel_name})
	set(CHANNEL_SUBSYSTEM ${_subsystem})
	string(LENGTH "${_type}" _type_length)
	string(TOUPPER "CHANNEL_${CHANNEL_NAME}_CLIENT" CHANNEL_PREFIX)
	if(_type_length GREATER 0)
		set(SUBSYSTEM_TYPE ${_type})
		set(MODULE_NAME "${CHANNEL_NAME}-client-${CHANNEL_SUBSYSTEM}-${SUBSYSTEM_TYPE}")
		string(TOUPPER "CHANNEL_${CHANNEL_NAME}_CLIENT_${CHANNEL_SUBSYSTEM}_${SUBSYSTEM_TYPE}" MODULE_PREFIX)
	else()
		set(MODULE_NAME "${CHANNEL_NAME}-client-${CHANNEL_SUBSYSTEM}")
		string(TOUPPER "CHANNEL_${CHANNEL_NAME}_CLIENT_${CHANNEL_SUBSYSTEM}" MODULE_PREFIX)
	endif()
endmacro(define_channel_client_subsystem)

macro(define_channel_server_subsystem _channel_name _subsystem _type)
	set(CHANNEL_NAME ${_channel_name})
	set(CHANNEL_SUBSYSTEM ${_subsystem})
	set(MODULE_NAME "${CHANNEL_NAME}-server-${CHANNEL_SUBSYSTEM}")
	string(TOUPPER "CHANNEL_${CHANNEL_NAME}_server_${CHANNEL_SUBSYSTEM}" MODULE_PREFIX)
endmacro(define_channel_server_subsystem)

macro(add_channel_client _channel_prefix _channel_name)
	add_subdirectory(client)
	if(${${_channel_prefix}_CLIENT_STATIC})
		set(CHANNEL_STATIC_CLIENT_MODULES ${CHANNEL_STATIC_CLIENT_MODULES} ${_channel_prefix} PARENT_SCOPE)
		set(${_channel_prefix}_CLIENT_NAME ${${_channel_prefix}_CLIENT_NAME} PARENT_SCOPE)
		set(${_channel_prefix}_CLIENT_CHANNEL ${${_channel_prefix}_CLIENT_CHANNEL} PARENT_SCOPE)
		set(${_channel_prefix}_CLIENT_ENTRY ${${_channel_prefix}_CLIENT_ENTRY} PARENT_SCOPE)
		set(CHANNEL_STATIC_CLIENT_ENTRIES ${CHANNEL_STATIC_CLIENT_ENTRIES} ${${_channel_prefix}_CLIENT_ENTRY} PARENT_SCOPE)
	endif()
endmacro(add_channel_client)

macro(add_channel_server _channel_prefix _channel_name)
	add_subdirectory(server)
	if(${${_channel_prefix}_SERVER_STATIC})
		set(CHANNEL_STATIC_SERVER_MODULES ${CHANNEL_STATIC_SERVER_MODULES} ${_channel_prefix} PARENT_SCOPE)
		set(${_channel_prefix}_SERVER_NAME ${${_channel_prefix}_SERVER_NAME} PARENT_SCOPE)
		set(${_channel_prefix}_SERVER_CHANNEL ${${_channel_prefix}_SERVER_CHANNEL} PARENT_SCOPE)
		set(${_channel_prefix}_SERVER_ENTRY ${${_channel_prefix}_SERVER_ENTRY} PARENT_SCOPE)
		set(CHANNEL_STATIC_SERVER_ENTRIES ${CHANNEL_STATIC_SERVER_ENTRIES} ${${_channel_prefix}_SERVER_ENTRY} PARENT_SCOPE)
	endif()
endmacro(add_channel_server)

macro(add_channel_client_subsystem _channel_prefix _channel_name _subsystem _type)
	add_subdirectory(${_subsystem})
	set(_channel_module_name "${_channel_name}-client")
	string(LENGTH "${_type}" _type_length)
	if(_type_length GREATER 0)
		string(TOUPPER "CHANNEL_${_channel_name}_CLIENT_${_subsystem}_${_type}" _subsystem_prefix)
	else()
		string(TOUPPER "CHANNEL_${_channel_name}_CLIENT_${_subsystem}" _subsystem_prefix)
	endif()
	if(${${_subsystem_prefix}_STATIC})
		get_target_property(CHANNEL_SUBSYSTEMS ${_channel_module_name} SUBSYSTEMS)
		if(_type_length GREATER 0)
			set(SUBSYSTEMS ${SUBSYSTEMS} "${_subsystem}-${_type}")
		else()
			set(SUBSYSTEMS ${SUBSYSTEMS} ${_subsystem})
		endif()
		set_target_properties(${_channel_module_name} PROPERTIES SUBSYSTEMS "${SUBSYSTEMS}")
	endif()
endmacro(add_channel_client_subsystem)

macro(add_channel_client_library _module_prefix _module_name _channel_name _dynamic _entry)
	if(${_dynamic} AND MSVC AND (NOT STATIC_CHANNELS))
		set(${_module_prefix}_SRCS ${${_module_prefix}_SRCS} module.def)
	endif()
	if(${_dynamic} AND (NOT STATIC_CHANNELS))
		add_library(${_module_name} ${${_module_prefix}_SRCS})
	else()
		set(${_module_prefix}_STATIC ON PARENT_SCOPE)
		set(${_module_prefix}_NAME ${_module_name} PARENT_SCOPE)
		set(${_module_prefix}_CHANNEL ${_channel_name} PARENT_SCOPE)
		set(${_module_prefix}_ENTRY ${_entry} PARENT_SCOPE)
		add_library(${_module_name} STATIC ${${_module_prefix}_SRCS})
	endif()
endmacro(add_channel_client_library)

macro(add_channel_client_subsystem_library _module_prefix _module_name _channel_name _type _dynamic _entry)
	if(${_dynamic} AND MSVC AND (NOT STATIC_CHANNELS))
		set(${_module_prefix}_SRCS ${${_module_prefix}_SRCS} module.def)
	endif()
	if(${_dynamic} AND (NOT STATIC_CHANNELS))
		add_library(${_module_name} ${${_module_prefix}_SRCS})
	else()
		set(${_module_prefix}_STATIC ON PARENT_SCOPE)
		set(${_module_prefix}_NAME ${_module_name} PARENT_SCOPE)
		set(${_module_prefix}_TYPE ${_type} PARENT_SCOPE)
		add_library(${_module_name} STATIC ${${_module_prefix}_SRCS})
	endif()
endmacro(add_channel_client_subsystem_library)

macro(add_channel_server_library _module_prefix _module_name _channel_name _dynamic _entry)
	if(${_dynamic} AND MSVC AND (NOT STATIC_CHANNELS))
		set(${_module_prefix}_SRCS ${${_module_prefix}_SRCS} module.def)
	endif()
	if(${_dynamic} AND (NOT STATIC_CHANNELS))
		add_library(${_module_name} ${${_module_prefix}_SRCS})
	else()
		set(${_module_prefix}_STATIC ON PARENT_SCOPE)
		set(${_module_prefix}_NAME ${_module_name} PARENT_SCOPE)
		set(${_module_prefix}_CHANNEL ${_channel_name} PARENT_SCOPE)
		set(${_module_prefix}_ENTRY ${_entry} PARENT_SCOPE)
		add_library(${_module_name} STATIC ${${_module_prefix}_SRCS})
	endif()
endmacro(add_channel_server_library)

set(FILENAME "ChannelOptions.cmake")
file(GLOB FILEPATHS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*/${FILENAME}")

foreach(FILEPATH ${FILEPATHS})
	if(${FILEPATH} MATCHES "^([^/]*)//${FILENAME}")
		string(REGEX REPLACE "^([^/]*)//${FILENAME}" "\\1" DIR ${FILEPATH})
		set(CHANNEL_OPTION)
		include(${FILEPATH})
		if(${CHANNEL_OPTION})
			set(CHANNEL_MESSAGE "Adding ${CHANNEL_TYPE} channel")
			if(${CHANNEL_CLIENT_OPTION})
				set(CHANNEL_MESSAGE "${CHANNEL_MESSAGE} client")
			endif()
			if(${CHANNEL_SERVER_OPTION})
				set(CHANNEL_MESSAGE "${CHANNEL_MESSAGE} server")
			endif()
			set(CHANNEL_MESSAGE "${CHANNEL_MESSAGE} \"${CHANNEL_NAME}\"")
			set(CHANNEL_MESSAGE "${CHANNEL_MESSAGE}: ${CHANNEL_DESCRIPTION}")
			message(STATUS "${CHANNEL_MESSAGE}")
			add_subdirectory(${DIR})
		endif()
	endif()
endforeach(FILEPATH)

if(WITH_CLIENT_CHANNELS)
	add_subdirectory(client)
	set(FREERDP_CHANNELS_CLIENT_SRCS ${FREERDP_CHANNELS_CLIENT_SRCS} PARENT_SCOPE)
	set(FREERDP_CHANNELS_CLIENT_LIBS ${FREERDP_CHANNELS_CLIENT_LIBS} PARENT_SCOPE)
endif()

if(WITH_SERVER_CHANNELS)
	add_subdirectory(server)
	set(FREERDP_CHANNELS_SERVER_SRCS ${FREERDP_CHANNELS_SERVER_SRCS} PARENT_SCOPE)
	set(FREERDP_CHANNELS_SERVER_LIBS ${FREERDP_CHANNELS_SERVER_LIBS} PARENT_SCOPE)
endif()

=== cunit/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# cunit cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include_directories(${CUNIT_INCLUDE_DIRS})
include_directories(${CMAKE_SOURCE_DIR}) # for some internal tests

include_directories(../libfreerdp/core)
include_directories(../libfreerdp/gdi)
include_directories(../libfreerdp/cache)
include_directories(../libfreerdp/codec)

add_executable(test_freerdp
	test_gcc.c
	test_gcc.h
	test_mcs.c
	test_mcs.h
	test_color.c
	test_color.h
	test_bitmap.c
	test_bitmap.h
	test_gdi.c
	test_gdi.h
	test_orders.c
	test_orders.h
	test_pcap.c
	test_pcap.h
	test_ntlm.c
	test_ntlm.h
	test_license.c
	test_license.h
	test_cliprdr.c
	test_cliprdr.h
	test_drdynvc.c
	test_drdynvc.h
	test_rfx.c
	test_rfx.h
	test_nsc.c
	test_nsc.h
	test_sspi.c
	test_sspi.h
	test_freerdp.c
	test_freerdp.h
	test_rail.c
	test_rail.h
	test_mppc.c
	test_mppc.h
	test_mppc_enc.c
	test_mppc_enc.h)

target_link_libraries(test_freerdp ${CUNIT_LIBRARIES})

target_link_libraries(test_freerdp freerdp-core)
target_link_libraries(test_freerdp freerdp-gdi)
target_link_libraries(test_freerdp freerdp-utils)
target_link_libraries(test_freerdp freerdp-codec)
target_link_libraries(test_freerdp freerdp-crypto)

target_link_libraries(test_freerdp winpr-sspi)

add_test(CUnitTests ${CMAKE_SOURCE_DIR}/cunit/test_freerdp)

=== include/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# include headers cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/freerdp/version.h.in ${CMAKE_CURRENT_BINARY_DIR}/freerdp/version.h)

file(GLOB FREERDP_HEADERS "freerdp/*.h")
install(FILES ${FREERDP_HEADERS} DESTINATION include/freerdp COMPONENT headers)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/freerdp/version.h DESTINATION include/freerdp COMPONENT headers)

install(DIRECTORY freerdp/cache DESTINATION include/freerdp COMPONENT headers FILES_MATCHING PATTERN "*.h")
install(DIRECTORY freerdp/codec DESTINATION include/freerdp COMPONENT headers FILES_MATCHING PATTERN "*.h")
install(DIRECTORY freerdp/crypto DESTINATION include/freerdp COMPONENT headers FILES_MATCHING PATTERN "*.h")
install(DIRECTORY freerdp/gdi DESTINATION include/freerdp COMPONENT headers FILES_MATCHING PATTERN "*.h")
install(DIRECTORY freerdp/locale DESTINATION include/freerdp COMPONENT headers FILES_MATCHING PATTERN "*.h")
install(DIRECTORY freerdp/rail DESTINATION include/freerdp COMPONENT headers FILES_MATCHING PATTERN "*.h")
install(DIRECTORY freerdp/utils DESTINATION include/freerdp COMPONENT headers FILES_MATCHING PATTERN "*.h")
install(DIRECTORY freerdp/client DESTINATION include/freerdp COMPONENT headers FILES_MATCHING PATTERN "*.h")
install(DIRECTORY freerdp/server DESTINATION include/freerdp COMPONENT headers FILES_MATCHING PATTERN "*.h")
install(DIRECTORY freerdp/channels DESTINATION include/freerdp COMPONENT headers FILES_MATCHING PATTERN "*.h")

=== server/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP Servers
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Servers

add_subdirectory(common)

if(WITH_SAMPLE)
	add_subdirectory(Sample)
endif()

if(NOT WIN32)
	if(WITH_X11)
		add_subdirectory(X11)
	endif()

	if(APPLE AND (NOT IOS))
		add_subdirectory(Mac)
	endif()
else()
	add_subdirectory(Windows)
endif()

if(WITH_WAYK)
	if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/WaykServer")
		add_subdirectory(WaykServer)
	endif()
endif()

if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/xrdp-ng")
	add_subdirectory("xrdp-ng")
endif()

=== third-party/CMakeLists.txt ===
# Third-Party Extensions
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# The third-party directory is meant for third-party components to be built
# as part of the main FreeRDP build system, making separate maintenance easier.
# Subdirectories of the third-party directory are ignored by git, but are
# automatically included by CMake when the -DWITH_THIRD_PARTY=on option is used.

file(GLOB all_valid_subdirs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*/CMakeLists.txt")

foreach(dir ${all_valid_subdirs})
	if(${dir} MATCHES "^([^/]*)//CMakeLists.txt")
		string(REGEX REPLACE "^([^/]*)//CMakeLists.txt" "\\1" dir_trimmed ${dir})
		message(STATUS "Adding third-party component ${dir_trimmed}")
		add_subdirectory(${dir_trimmed})
	endif()
endforeach(dir)

set(THIRD_PARTY_INCLUDES ${THIRD_PARTY_INCLUDES} PARENT_SCOPE)

=== winpr/CMakeLists.txt ===
# WinPR: Windows Portable Runtime
# winpr cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 2.8)

project(WinPR C)

set(CMAKE_COLOR_MAKEFILE ON)

if(FREERDP_VERSION)
	set(FREERDP_BUILD)
endif()

# Include cmake modules
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckStructHasMember)
include(FindPkgConfig)
include(TestBigEndian)

# Include our extra modules
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../cmake/)

# Check for cmake compatibility (enable/disable features)
include(CheckCmakeCompat)

include(FindFeature)
include(AutoVersioning)
include(ConfigOptions)
include(CheckCCompilerFlag)
include(GNUInstallDirsWrapper)

# Soname versioning
set(WINPR_VERSION_MAJOR "0")
set(WINPR_VERSION_MINOR "1")
set(WINPR_VERSION_REVISION "0")
set(WINPR_VERSION "${WINPR_VERSION_MAJOR}.${WINPR_VERSION_MINOR}")
set(WINPR_VERSION_FULL "${WINPR_VERSION}.${WINPR_VERSION_REVISION}")

# Default to release build type
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
endif()

# Default to build shared libs
if(NOT DEFINED BUILD_SHARED_LIBS)
	set(BUILD_SHARED_LIBS ON)
endif()

if(FREERDP_BUILD)
	include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include PARENT_SCOPE)
	include_directories(${CMAKE_CURRENT_BINARY_DIR}/include PARENT_SCOPE)
else()
	include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
	include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)
endif()

add_subdirectory(include)

add_subdirectory(libwinpr)

if(NOT ANDROID AND NOT IOS)
	add_subdirectory(tools)
endif()

=== channels/client/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(MODULE_NAME "freerdp-channels-client")
set(MODULE_PREFIX "FREERDP_CHANNELS_CLIENT")

set(${MODULE_PREFIX}_SRCS
	${CMAKE_CURRENT_BINARY_DIR}/tables.c
	${CMAKE_CURRENT_SOURCE_DIR}/tables.h
	${CMAKE_CURRENT_SOURCE_DIR}/addin.c
	${CMAKE_CURRENT_SOURCE_DIR}/addin.h
	${CMAKE_CURRENT_SOURCE_DIR}/init.c
	${CMAKE_CURRENT_SOURCE_DIR}/init.h
	${CMAKE_CURRENT_SOURCE_DIR}/open.c
	${CMAKE_CURRENT_SOURCE_DIR}/open.h
	${CMAKE_CURRENT_SOURCE_DIR}/channels.c
	${CMAKE_CURRENT_SOURCE_DIR}/channels.h)

list(REMOVE_DUPLICATES CHANNEL_STATIC_CLIENT_ENTRIES)

foreach(STATIC_ENTRY ${CHANNEL_STATIC_CLIENT_ENTRIES})
	foreach(STATIC_MODULE ${CHANNEL_STATIC_CLIENT_MODULES})
		if(${${STATIC_MODULE}_CLIENT_ENTRY} STREQUAL ${STATIC_ENTRY})
			set(STATIC_MODULE_NAME ${${STATIC_MODULE}_CLIENT_NAME})
			set(STATIC_MODULE_CHANNEL ${${STATIC_MODULE}_CLIENT_CHANNEL})
			set(${MODULE_PREFIX}_LIBS ${${MODULE_PREFIX}_LIBS} ${STATIC_MODULE_NAME})
			
			set(ENTRY_POINT_NAME "${STATIC_MODULE_CHANNEL}_${${STATIC_MODULE}_CLIENT_ENTRY}")
			set(ENTRY_POINT_IMPORT "extern void ${ENTRY_POINT_NAME}();")
			set(${STATIC_ENTRY}_IMPORTS "${${STATIC_ENTRY}_IMPORTS}\n${ENTRY_POINT_IMPORT}")
			set(${STATIC_ENTRY}_TABLE "${${STATIC_ENTRY}_TABLE}\n\t{ \"${STATIC_MODULE_CHANNEL}\", ${ENTRY_POINT_NAME} },")
		endif()
	endforeach()
endforeach()

set(CLIENT_STATIC_ENTRY_TABLES_LIST "${CLIENT_STATIC_ENTRY_TABLES_LIST}\nconst STATIC_ENTRY_TABLE CLIENT_STATIC_ENTRY_TABLES[] =\n{")

foreach(STATIC_ENTRY ${CHANNEL_STATIC_CLIENT_ENTRIES})
	set(CLIENT_STATIC_ENTRY_IMPORTS "${CLIENT_STATIC_ENTRY_IMPORTS}\n${${STATIC_ENTRY}_IMPORTS}")
	set(CLIENT_STATIC_ENTRY_TABLES "${CLIENT_STATIC_ENTRY_TABLES}\nconst STATIC_ENTRY CLIENT_${STATIC_ENTRY}_TABLE[] =\n{")
	set(CLIENT_STATIC_ENTRY_TABLES "${CLIENT_STATIC_ENTRY_TABLES}\n${${STATIC_ENTRY}_TABLE}")
	set(CLIENT_STATIC_ENTRY_TABLES "${CLIENT_STATIC_ENTRY_TABLES}\n\t{ NULL, NULL }\n};")
	set(CLIENT_STATIC_ENTRY_TABLES_LIST "${CLIENT_STATIC_ENTRY_TABLES_LIST}\n\t{ \"${STATIC_ENTRY}\", CLIENT_${STATIC_ENTRY}_TABLE },")
endforeach()

set(CLIENT_STATIC_ENTRY_TABLES_LIST "${CLIENT_STATIC_ENTRY_TABLES_LIST}\n\t{ NULL, NULL }\n};")

set(CLIENT_STATIC_ADDIN_TABLE "const STATIC_ADDIN_TABLE CLIENT_STATIC_ADDIN_TABLE[] =\n{")
foreach(STATIC_MODULE ${CHANNEL_STATIC_CLIENT_MODULES})
	set(STATIC_MODULE_NAME ${${STATIC_MODULE}_CLIENT_NAME})
	set(STATIC_MODULE_CHANNEL ${${STATIC_MODULE}_CLIENT_CHANNEL})
	string(TOUPPER "CLIENT_${STATIC_MODULE_CHANNEL}_SUBSYSTEM_TABLE" SUBSYSTEM_TABLE_NAME)
	set(SUBSYSTEM_TABLE "const STATIC_SUBSYSTEM_ENTRY ${SUBSYSTEM_TABLE_NAME}[] =\n{")
	get_target_property(CHANNEL_SUBSYSTEMS ${STATIC_MODULE_NAME} SUBSYSTEMS)
	if(CHANNEL_SUBSYSTEMS MATCHES "NOTFOUND")
		set(CHANNEL_SUBSYSTEMS "")
	endif()
	foreach(STATIC_SUBSYSTEM ${CHANNEL_SUBSYSTEMS})
		if(${STATIC_SUBSYSTEM} MATCHES "^([^-]*)-(.*)")
			string(REGEX REPLACE "^([^-]*)-(.*)" "\\1" STATIC_SUBSYSTEM_NAME ${STATIC_SUBSYSTEM})
			string(REGEX REPLACE "^([^-]*)-(.*)" "\\2" STATIC_SUBSYSTEM_TYPE ${STATIC_SUBSYSTEM})
		else()
			set(STATIC_SUBSYSTEM_NAME "${STATIC_SUBSYSTEM}")
			set(STATIC_SUBSYSTEM_TYPE "")
		endif()
		string(LENGTH "${STATIC_SUBSYSTEM_TYPE}" _type_length)
		set(SUBSYSTEM_MODULE_NAME "${STATIC_MODULE_NAME}-${STATIC_SUBSYSTEM}")
		set(${MODULE_PREFIX}_LIBS ${${MODULE_PREFIX}_LIBS} ${SUBSYSTEM_MODULE_NAME})
		if(_type_length GREATER 0)
			set(STATIC_SUBSYSTEM_ENTRY "${STATIC_SUBSYSTEM_NAME}_freerdp_${STATIC_MODULE_CHANNEL}_client_${STATIC_SUBSYSTEM_TYPE}_subsystem_entry")
		else()
			set(STATIC_SUBSYSTEM_ENTRY "${STATIC_SUBSYSTEM_NAME}_freerdp_${STATIC_MODULE_CHANNEL}_client_subsystem_entry")
		endif()
		set(SUBSYSTEM_TABLE "${SUBSYSTEM_TABLE}\n\t{ \"${STATIC_SUBSYSTEM_NAME}\", \"${STATIC_SUBSYSTEM_TYPE}\", ${STATIC_SUBSYSTEM_ENTRY} },")
		set(SUBSYSTEM_IMPORT "extern void ${STATIC_SUBSYSTEM_ENTRY}();")
		set(CLIENT_STATIC_SUBSYSTEM_IMPORTS "${CLIENT_STATIC_SUBSYSTEM_IMPORTS}\n${SUBSYSTEM_IMPORT}")
	endforeach()
	set(SUBSYSTEM_TABLE "${SUBSYSTEM_TABLE}\n\t{ NULL, NULL, NULL }\n};")
	set(CLIENT_STATIC_SUBSYSTEM_TABLES "${CLIENT_STATIC_SUBSYSTEM_TABLES}\n${SUBSYSTEM_TABLE}")
	set(ENTRY_POINT_NAME "${STATIC_MODULE_CHANNEL}_${${STATIC_MODULE}_CLIENT_ENTRY}")
	set(CLIENT_STATIC_ADDIN_TABLE "${CLIENT_STATIC_ADDIN_TABLE}\n\t{ \"${STATIC_MODULE_CHANNEL}\", ${ENTRY_POINT_NAME}, ${SUBSYSTEM_TABLE_NAME} },")
endforeach()
set(CLIENT_STATIC_ADDIN_TABLE "${CLIENT_STATIC_ADDIN_TABLE}\n\t{ NULL, NULL, NULL }\n};")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/tables.c.in ${CMAKE_CURRENT_BINARY_DIR}/tables.c)

set_complex_link_libraries(VARIABLE ${MODULE_PREFIX}_LIBS
	MONOLITHIC ${MONOLITHIC_BUILD}
	MODULE freerdp
	MODULES freerdp-utils)

set_complex_link_libraries(VARIABLE ${MODULE_PREFIX}_LIBS
	MONOLITHIC ${MONOLITHIC_BUILD}
	MODULE winpr
	MODULES winpr-crt winpr-path winpr-file winpr-synch winpr-library winpr-interlocked)

set(${MODULE_PREFIX}_SRCS ${${MODULE_PREFIX}_SRCS} PARENT_SCOPE)
set(${MODULE_PREFIX}_LIBS ${${MODULE_PREFIX}_LIBS} PARENT_SCOPE)

=== channels/cliprdr/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

define_channel("cliprdr")

if(WITH_CLIENT_CHANNELS)
	add_channel_client(${MODULE_PREFIX} ${CHANNEL_NAME})
endif()

=== channels/drdynvc/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

define_channel("drdynvc")

if(WITH_CLIENT_CHANNELS)
	add_channel_client(${MODULE_PREFIX} ${CHANNEL_NAME})
endif()

=== channels/echo/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

define_channel("echo")

if(WITH_CLIENT_CHANNELS)
	add_channel_client(${MODULE_PREFIX} ${CHANNEL_NAME})
endif()

=== channels/rdpdr/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

define_channel("rdpdr")

if(WITH_CLIENT_CHANNELS)
	add_channel_client(${MODULE_PREFIX} ${CHANNEL_NAME})
endif()

=== channels/rdpei/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

define_channel("rdpei")

if(WITH_CLIENT_CHANNELS)
	add_channel_client(${MODULE_PREFIX} ${CHANNEL_NAME})
endif()

=== debian/changelog ===
freerdp (1.1.0~git20140921.1.440916e+dfsg1-7+alpha) unreleased; urgency=medium

  * Fix alignment of reference utf16 strings in test suite.
    Fixes FTBFS on Alpha (#800716)

 -- Michael Cree <mcree@orcon.net.nz>  Mon, 25 Apr 2016 22:49:57 +1200

=== debian/control ===
Source: freerdp
Section: x11
Priority: optional
Maintainer: Mike Gabriel <sunweaver@debian.org>
Uploaders:
 Otavio Salvador <otavio@debian.org>,
 Laszlo Boszormenyi (GCS) <gcs@debian.hu>,
Build-Depends:
 debhelper (>= 9),
 cdbs,
 autotools-dev,
 cmake,
 dpkg-dev (>= 1.16.1.1),
 libasound2-dev,
 libcups2-dev,
 libpcsclite-dev,
 libpulse-dev,
 libssl-dev,
 libx11-dev,
 libxcursor-dev,
 libxdamage-dev,
 libxext-dev,
 libxkbfile-dev,
 libxinerama-dev,
 libxrandr-dev,
 libxv-dev,
 libjpeg-dev,
 pkg-config,
 xmlto,
 libavcodec-dev,
 libxi-dev,
 libusb-1.0-0-dev,
 libudev-dev,
 libdbus-glib-1-dev,
 uuid-dev,
Standards-Version: 3.9.6
Homepage: http://www.freerdp.com/
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/freerdp.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/freerdp.git

Package: freerdp-x11
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libfreerdp-plugins-standard
Provides: freerdp
Description: RDP client for Windows Terminal Services (X11 client)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 Currently, the FreeRDP client supports the following Windows Versions:
 .
  * Windows NT Server
  * Windows 2000 Terminal Server
  * Windows XP
  * Windows 2003 Server
  * Windows Vista
  * Windows 2008/2008r2/2011SBS Server
  * Windows 7
  * Windows 2012 Server
  * Windows 8
 .
 This package contains the X11 based client.

Package: libfreerdp-cache1.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Free Remote Desktop Protocol library (cache library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the cache shared library.

Package: libfreerdp-client1.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Free Remote Desktop Protocol library (client library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the freerdp-client shared library.

Package: libfreerdp-codec1.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Free Remote Desktop Protocol library (codec library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the freerdp-codec shared library.

Package: libfreerdp-common1.1.0
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Free Remote Desktop Protocol library (common library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the freerdp-common shared library.

Package: libfreerdp-core1.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Free Remote Desktop Protocol library (core library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the freerdp-core shared library.

Package: libfreerdp-crypto1.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Free Remote Desktop Protocol library (freerdp-crypto library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the freerdp-crypto shared library.

Package: libfreerdp-gdi1.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Free Remote Desktop Protocol library (GDI library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the freerdp-gdi shared library.

Package: libfreerdp-locale1.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Free Remote Desktop Protocol library (locale library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the freerdp-locale shared library.

Package: libfreerdp-primitives1.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Free Remote Desktop Protocol library (primitives library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the freerdp-primitives shared library.

Package: libfreerdp-rail1.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Free Remote Desktop Protocol library (rail library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the freerdp-rail shared library.

Package: libfreerdp-utils1.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Free Remote Desktop Protocol library (freerdp-utils library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the freerdp-utils shared library.

Package: libwinpr-asn1-0.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Windows Portable Runtime library (ASN1 library)
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .
 This package contains the winpr-asn1 shared library.

Package: libwinpr-bcrypt0.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Windows Portable Runtime library (bcrypt library)
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .
 This package contains the winpr-bcrypt shared library.

Package: libwinpr-credentials0.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Windows Portable Runtime library (credentials library)
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .
 This package contains the winpr-credentials shared library.

Package: libwinpr-credui0.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Windows Portable Runtime library (credeui library)
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .
 This package contains the winpr-credeui shared library.

Package: libwinpr-crt0.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Suggests: freerdp-x11
Breaks: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Replaces: libfreerdp1 (<< 1.1.0~git20140921.1.440916e+dfsg-1)
Description: Windows Portable Runtime library (crt library)
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

NULL =

DEB_HOST_ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)
ifneq (,$(filter armhf,$(DEB_HOST_ARCH)))
ARM_FLOAT_ABI = -DARM_FP_ABI=hard
else
ARM_FLOAT_ABI =
endif

include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_DH_INSTALL_ARGS += --fail-missing

DEB_CMAKE_EXTRA_FLAGS :=  -DCMAKE_INSTALL_INCLUDEDIR=include/$(shell dpkg-architecture -qDEB_BUILD_MULTIARCH) \
                          -DCMAKE_SKIP_RPATH=FALSE \
                          -DCMAKE_SKIP_INSTALL_RPATH=TRUE \
                          -DBUILD_TESTING=ON \
                          -DWITH_SERVER=OFF \
                          -DWITH_PULSE=ON \
                          -DWITH_GSTREAMER=OFF \
                          -DWITH_CHANNELS=ON \
                          -DSTATIC_CHANNELS=off \
                          -DWITH_CUPS=on \
                          -DWITH_PCSC=on \
                          -DWITH_JPEG=on \
                          -DCHANNEL_URBDRC_CLIENT=on \
                          $(ARM_FLOAT_ABI) \
                          $(NULL)

DEB_MAKE_CHECK_TARGET := test

DEB_DH_MAKESHLIBS_ARGS_libfreerdp-plugins-standard = -X/freerdp/ -V -- -c4

common-install-indep:: remove-cruft tweak-install
common-install-arch:: remove-cruft tweak-install

DEB_DH_STRIP_ARGS_libwinpr-asn1-0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-bcrypt0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-credentials0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-credui0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-crt0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-crypto0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-dsparse0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-environment0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-error0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-file0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-handle0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-heap0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-input0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-interlocked0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-io0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-library0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-path0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-pipe0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-pool0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-registry0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-rpc0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-sspi0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-sspicli0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-synch0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-sysinfo0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-thread0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-timezone0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-utils0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-winhttp0.1 = --dbg-package=libwinpr-dbg
DEB_DH_STRIP_ARGS_libwinpr-winsock0.1 = --dbg-package=libwinpr-dbg

DEB_DH_STRIP_ARGS_libfreerdp-cache1.1 = --dbg-package=libfreerdp-dbg
DEB_DH_STRIP_ARGS_libfreerdp-client1.1 = --dbg-package=libfreerdp-dbg
DEB_DH_STRIP_ARGS_libfreerdp-codec1.1 = --dbg-package=libfreerdp-dbg
DEB_DH_STRIP_ARGS_libfreerdp-common1.1.0 = --dbg-package=libfreerdp-dbg
DEB_DH_STRIP_ARGS_libfreerdp-core1.1 = --dbg-package=libfreerdp-dbg
DEB_DH_STRIP_ARGS_libfreerdp-crypto1.1 = --dbg-package=libfreerdp-dbg
DEB_DH_STRIP_ARGS_libfreerdp-gdi1.1 = --dbg-package=libfreerdp-dbg
DEB_DH_STRIP_ARGS_libfreerdp-locale1.1 = --dbg-package=libfreerdp-dbg
DEB_DH_STRIP_ARGS_libfreerdp-primitives1.1 = --dbg-package=libfreerdp-dbg
DEB_DH_STRIP_ARGS_libfreerdp-rail1.1 = --dbg-package=libfreerdp-dbg
DEB_DH_STRIP_ARGS_libfreerdp-utils1.1 = --dbg-package=libfreerdp-dbg

DEB_DH_STRIP_ARGS_libfreerdp-plugins-standard = --dbg-package=libfreerdp-plugins-standard-dbg

DEB_DH_STRIP_ARGS_freerdp-x11 = --dbg-package=freerdp-x11-dbg
DEB_DH_STRIP_ARGS_libxfreerdp-client1.1 = --dbg-package=libxfreerdp-client-dbg

remove-cruft::
	rm -f debian/tmp/usr/lib/$(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)/libwinpr-makecert-tool.a
	rm -f debian/tmp/usr/lib/$(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)/freerdp/cliprdr-client.a

tweak-install::
	@echo "Nothing to tweak after installation."

clean::
	rm -f include/version.h
	rm -f config.h

PKD   = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
PKG   = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
UVER  = $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s+(?:\d+:)?(\d.*)(?:\-\d+.*)};')
DTYPE = +dfsg1
VER  ?= $(subst $(DTYPE),,$(UVER))

UURL = git://github.com/FreeRDP/FreeRDP.git
UREV = $(shell echo $(VER) | cut -d"." -f5)

## http://wiki.debian.org/onlyjob/get-orig-source
.PHONY: get-orig-source
get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
	@

$(PKG)_$(VER)$(DTYPE).orig.tar.xz: $(info I: GIT Revision=$(UREV))
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Downloading..."
	git clone $(UURL) $(PKG)-$(VER) \
	    || $(RM) -r $(PKG)-$(VER)
	cd $(PKG)-$(VER) \
	    && git checkout "$(UREV)" \
	    && ( echo "# Generating ChangeLog..." \
	       ; git --no-pager log --format="%ai %aN (%h) %n%n%x09*%w(68,0,10) %s%d%n" > ChangeLog \
	       ; touch -d "$$(git log -1 --format='%ci')" ChangeLog) \
	    && echo "# Setting times..." \
	    && for F in $$(git ls-tree -r --name-only HEAD); do touch --no-dereference -d "$$(git log -1 --format="%ai" -- $$F)" "$$F"; done \
	    && echo "# Cleaning-up..." \
	    && rm -rf \
	        client/Android/ \
	        client/iOS/ \
	        client/Mac/ \
	        client/Windows/ \
	        scripts/OpenSSL-DownloadAndBuild.command \
	    && $(RM) -r .git .git*
	@echo "# Packing..."
	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
	    | XZ_OPT="-6v" tar -caf "$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
	    && $(RM) -r "$(PKG)-$(VER)"
